variable "application_name" {
  type = string
}

variable "namespace" {
  default = "default"
  type    = string
}

variable "image" {
  type = object({
    name        = string
    tag         = optional(string, "latest")
    pull-policy = optional(string, "Always")
  })
}

variable "args" {
  type    = list(string)
  default = null
}

variable "ports" {
  type = list(
    object({
      container_port = number
      expose         = optional(bool, false)
    })
  )
  default = []
}

variable "env" {
  type = list(
    object({
      name  = string
      value = string
    })
  )
  default = []
}

variable "config_content" {
  type    = string
  default = null
}

variable "volumes" {
  type = map(
    object({
      path = string
    })
  )
  default = {}
}

variable "replicas" {
  type = number
  default = 1
  description = "number of replicas for the application's pod"
}

variable "additional_ingress_host" {
  type = list(string)
  default = []
  description = "list of additional ingress host allowed for this service"
}

variable "is_test" {
  type = bool
  default = false
  description = "mode to declare if the module is run in terraform test mode or in classical mode"
}